//Maple Chat, A simple chat app made with cap'n proto
//Copyright (C) 2023  Roux Pupo
//
//This program is free software: you can redistribute it and/or modify
//it under the terms of the GNU Affero General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU Affero General Public License for more details.
//
//You should have received a copy of the GNU Affero General Public License
//along with this program.  If not, see <https://www.gnu.org/licenses/>.

use capnpc;
use std::process::Command;

fn main() {
    capnpc::CompilerCommand::new()
        .output_path("src/schema")
        .src_prefix("src/schema")
        .file("src/schema/protocol.capnp")
        .run()
        .unwrap();
    let result = Command::new("rustfmt")
        .arg("src/schema/protocol.capnp")
        .output()
        .expect("rustfmt failure");
    println!("{}", String::from_utf8_lossy(&result.stdout));
    eprintln!("{}", String::from_utf8_lossy(&result.stderr));
}
