//Maple Chat, A simple chat app made with cap'n proto
//Copyright (C) 2023  Roux Pupo
//
//This program is free software: you can redistribute it and/or modify
//it under the terms of the GNU Affero General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU Affero General Public License for more details.
//
//You should have received a copy of the GNU Affero General Public License
//along with this program.  If not, see <https://www.gnu.org/licenses/>.

use capnp::message::{Builder, ReaderOptions};
use capnp::serialize;
use maple_rpc::protocol_capnp::*;

fn main() {
    let mut message = Builder::new_default();
    let mut person = message.init_root::<user::Builder>();
    person.set_name("Mocha");
    person.set_age(19);

    let data = serialize::write_message_to_words(&message);

    let reader = serialize::read_message(data.as_slice(), ReaderOptions::new()).unwrap();
    let retrieved = reader.get_root::<user::Reader>().unwrap();
    println!("{:?}", retrieved.get_name());
}

